package org.processmining.v7.bruteforce;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JCheckBox;
import javax.swing.JComponent;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.info.impl.XLogInfoImpl;
import org.deckfour.xes.model.XLog;
import org.processmining.framework.util.ui.widgets.ProMComboBox;
import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.framework.util.ui.wizard.ProMWizardStep;

import com.fluxicon.slickerbox.components.NiceDoubleSlider;
import com.fluxicon.slickerbox.components.NiceSlider.Orientation;
import com.fluxicon.slickerbox.factory.SlickerFactory;

public class MyMinerWizardStep extends ProMPropertiesPanel implements ProMWizardStep<MyParameters> {
	public static String TITLE = "Configure eST-Miner parameters";
	NiceDoubleSlider threshold;
	ProMComboBox<String> classifierComboBox;
	JCheckBox safenessBox;
	
	XLog log;
	
	public MyMinerWizardStep(String title) {
		super(title);
		// TODO Auto-generated constructor stub
	}
	
	public MyMinerWizardStep(XLog log) {
		super(TITLE);
		this.threshold = SlickerFactory.instance().createNiceDoubleSlider("Threshold Tau ", 0, 1, 1, Orientation.HORIZONTAL);
		this.log = log;		
		List<XEventClassifier> logClassifiers = log.getClassifiers();
		List<String> logClassifiersLabels = new ArrayList<String>();
		for (XEventClassifier classifier : logClassifiers) {
			logClassifiersLabels.add(classifier.toString());
		}
		
		System.out.println("classifiers = ");
		System.out.println(logClassifiersLabels);
		
		classifierComboBox = this.addComboBox("Classifiers", logClassifiersLabels);
		this.add(this.threshold);
		safenessBox = this.addCheckBox("Safeness", true);
		
	}

	public MyParameters apply(MyParameters model, JComponent component) {
		double threshold_result = this.threshold.getValue();
		
		List<XEventClassifier> logClassifiers = log.getClassifiers();
		XEventClassifier classifierToUse = XLogInfoImpl.STANDARD_CLASSIFIER;
		for (XEventClassifier classifier : logClassifiers) {
			if (classifier.toString().equals(classifierComboBox.getSelectedItem().toString())) {
				classifierToUse = classifier;
				System.out.println("selecting classifier "+classifierToUse);
				break;
			}
		}
		
		MyParameters parameters = new MyParameters(threshold_result, classifierToUse, safenessBox.isSelected());
		
		return parameters;
	}

	public boolean canApply(MyParameters model, JComponent component) {
		// TODO Auto-generated method stub
		return true;
	}

	public JComponent getComponent(MyParameters model) {
		// TODO Auto-generated method stub
		return this;
	}

	public String getTitle() {
		// TODO Auto-generated method stub
		return TITLE;
	}

}