package org.processmining.v7.bruteforce;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.info.impl.XLogInfoImpl;
import org.processmining.basicutils.parameters.impl.PluginParametersImpl;

public class MyParameters  extends PluginParametersImpl {
	private double threshold; 
	private long timeAllowance;
	private XEventClassifier classifier;
	private int inOneOutThis;
	private int inThisOutOne;
	private int inXoutY_X;
	private int inXoutY_Y;
	private Integer[] place_restrictions = new Integer[4];
	private boolean safeness;
	
	public MyParameters(double threshold, XEventClassifier classifier, boolean safeness) {
		this.threshold = threshold;
		this.classifier = classifier;
		this.safeness = safeness;
		//parameters that stay fixed for now
		this.timeAllowance = Long.MAX_VALUE; //time allowed for finding places in ms
		this.inOneOutThis = Integer.MAX_VALUE;
		this.inThisOutOne = Integer.MAX_VALUE;
		this.inXoutY_X = Integer.MAX_VALUE;
		this.inXoutY_Y = Integer.MAX_VALUE;
		this.place_restrictions[0] = this.inOneOutThis;
		this.place_restrictions[1] = this.inThisOutOne;
		this.place_restrictions[2] = this.inXoutY_X;
		this.place_restrictions[3] = this.inXoutY_Y;
	}
	
	public MyParameters() {
		this.threshold = 1; //fraction of fitting traces for a place to be inserted
		this.timeAllowance = Long.MAX_VALUE; //time allowed for finding places in ms
		this.classifier = XLogInfoImpl.STANDARD_CLASSIFIER; //classifier used to extract transitions from the log
		this.inOneOutThis = Integer.MAX_VALUE;
		this.inThisOutOne = Integer.MAX_VALUE;
		this.inXoutY_X = Integer.MAX_VALUE;
		this.inXoutY_Y = Integer.MAX_VALUE;
		this.place_restrictions[0] = this.inOneOutThis;
		this.place_restrictions[1] = this.inThisOutOne;
		this.place_restrictions[2] = this.inXoutY_X;
		this.place_restrictions[3] = this.inXoutY_Y;
		this.safeness = true;
	}

	public double getThreshold() {
		return threshold;
	}

	public long getTimeAllowance() {
		return timeAllowance;
	}

	public XEventClassifier getClassifier() {
		return classifier;
	}

	public int getInOneOutThis() {
		return inOneOutThis;
	}

	public int getInThisOutOne() {
		return inThisOutOne;
	}

	public int getInXoutY_X() {
		return inXoutY_X;
	}

	public int getInXoutY_Y() {
		return inXoutY_Y;
	}

	public Integer[] getPlace_restrictions() {
		return place_restrictions;
	}

	public boolean isSafeness() {
		return safeness;
	}

	public void setThreshold(double threshold) {
		this.threshold = threshold;
	}

	public void setTimeAllowance(long timeAllowance) {
		this.timeAllowance = timeAllowance;
	}

	public void setClassifier(XEventClassifier classifier) {
		this.classifier = classifier;
	}

	public void setInOneOutThis(int inOneOutThis) {
		this.inOneOutThis = inOneOutThis;
	}

	public void setInThisOutOne(int inThisOutOne) {
		this.inThisOutOne = inThisOutOne;
	}

	public void setInXoutY_X(int inXoutY_X) {
		this.inXoutY_X = inXoutY_X;
	}

	public void setInXoutY_Y(int inXoutY_Y) {
		this.inXoutY_Y = inXoutY_Y;
	}

	public void setPlace_restrictions(Integer[] place_restrictions) {
		this.place_restrictions = place_restrictions;
	}

	public void setSafeness(boolean safeness) {
		this.safeness = safeness;
	}
}