package org.processmining.v7.bruteforce;

public class ProcessDiscovery extends Thread {

	private final MyProcessModel pM;
	private final MyCandidates candidates;
	private final MyPlaceEvaluator evaluator;

	public ProcessDiscovery(final MyProcessModel pM, final MyCandidates candidates, final MyPlaceEvaluator evaluator) {
		this.pM = pM;
		this.candidates = candidates;
		this.evaluator = evaluator;
	}

	@Override
	public void run() {
			try {
				addPlaces();
				System.out.println("Finished adding places without interuption.");

			} catch (InterruptedException e) {
			System.out.println("Interupted Exception thrown!");
			}
	}

	private void addPlaces() throws InterruptedException {
		MyPlace current = candidates.getNext(null, PlaceStatus.FIT);
		while (current != null) {
			if (!this.isInterrupted()) {
				PlaceStatus fitness = evaluator.testPlace(current);
				if (fitness == PlaceStatus.FIT) {
					pM.addPlace(current);
				}
				long startTimeCandFind = System.currentTimeMillis();
				current = candidates.getNext(current, fitness);
				PlugInStatistics.instance().incTimeCandFind(System.currentTimeMillis() - startTimeCandFind);
			}
			else {
				System.out.println("!!!Timelimit for adding places has been reached!!!");
				break;
			}
		}
	}

	//G&S
	public MyProcessModel getpM() {
		return pM;
	}
}
