package org.processmining.v7.postproc_after_tc;

import java.util.ArrayList;

class RedundancyTester {
	private int thresholdRed = 20; //to keep time spend on redundancy test low, bad solution TODO

	public RedundancyTester() {
	}

	//Redundancy (according to monotonicity paper)
	public MyProcessModel testForRedundancy(final MyProcessModel pM, final int threshold) {
		this.thresholdRed=threshold;
		MyProcessModel newPM = new MyProcessModel(new ArrayList<MyPlace>(), pM.getTransitions());
		ArrayList<MyPlace> finalists = new ArrayList<MyPlace>();
		finalists = pM.getPlaces();
		finalists.sort(null);
		for (MyPlace p : finalists) {
			if (isRedundant(p, newPM)) {
			} else {
				newPM.addPlace(p);
			}
		}
		return newPM;
	}

	//check whether a new place is redundant with respect to the places already in the model (definition monotonicity paper)
	boolean isRedundant(final MyPlace newPlace, final MyProcessModel pM) {
		int in = newPlace.getInputTrKey();
		int out = newPlace.getOutputTrKey();
		ArrayList<MyPlace> testSet = new ArrayList<MyPlace>();
		for (MyPlace p : pM.getPlaces()) {
			if (((p.getInputTrKey() | in) == in) && ((p.getOutputTrKey() | out) == out)) {//ensure subset
				testSet.add(p);
			}
		}
		if (testSet.size() > thresholdRed) {
	//		System.out.println("Stopped redundancy testing due to set size!");
			return false;
		}
		//check every subset of the testset until redundancy is found
		for (int key = 0; key < Math.pow(2, testSet.size()); key++) {
			int allIn = 0;
			int allOut = 0;
			for (int i = 0; i < testSet.size(); i++) {
				if ((key & (1 << i)) > 0) {
					MyPlace pInSubset = testSet.get(i);
					if (((allIn & pInSubset.getInputTrKey()) > 0) || ((allOut & pInSubset.getOutputTrKey()) > 0)) {//ensure disjointness
						break;
					} else {
						allIn = allIn | pInSubset.getInputTrKey();
						allOut = allOut | pInSubset.getOutputTrKey();
					}
				}
			}
			if ((allIn == in) && (allOut == out)) {
				return true;
			}
		}
		return false;
	}

	public boolean isRedundant2(MyPlace current, MyProcessModel pM) {
		int in = current.getInputTrKey();
		int out = current.getOutputTrKey();
		ArrayList<MyPlace> testSet = new ArrayList<MyPlace>();
		for (MyPlace p : pM.getPlaces()) {
			if (((p.getInputTrKey() | in) == in) && ((p.getOutputTrKey() | out) == out)) {//ensure subset
				testSet.add(p);
			}
		}
		if (testSet.size() > thresholdRed) {
	//		System.out.println("Stopped redundancy testing due to set size!");
			return false;
		}
		//check every subset of the testset until redundancy is found
		for (int key = 0; key < Math.pow(2, testSet.size()); key++) {
			int allIn = 0;
			int allOut = 0;
			for (int i = 0; i < testSet.size(); i++) {
				if ((key & (1 << i)) > 0) {
					MyPlace pInSubset = testSet.get(i);
					if (((allIn & pInSubset.getInputTrKey()) > 0) || ((allOut & pInSubset.getOutputTrKey()) > 0)) {//ensure disjointness
						break;
					} else {
						allIn = allIn | pInSubset.getInputTrKey();
						allOut = allOut | pInSubset.getOutputTrKey();
					}
				}
			}
			if ((allIn == in) && (allOut == out)) {
				return true;
			}
		}
		return false;
	}

}
