package org.processmining.v7.postproc_during_tc;

public class ProcessDiscovery extends Thread {

	private MyProcessModel pM;
	private final MyCandidates candidates;
	private final MyPlaceEvaluator evaluator;

	public ProcessDiscovery(final MyProcessModel pM, final MyCandidates candidates, final MyPlaceEvaluator evaluator) {
		this.pM = pM;
		this.candidates = candidates;
		this.evaluator = evaluator;
	}

	@Override
	public void run() {
			try {
				addPlaces();
				System.out.println("Finished adding places without interuption.");

			} catch (InterruptedException e) {
			System.out.println("Interupted Exception thrown!");
			}
	}

	private void addPlaces() throws InterruptedException {
		RedundancyTester redundancyTester = new RedundancyTester();
		ImplicitnessTester implicitnessTester = new ImplicitnessTester();
		MyPlace current = candidates.getNext(null, PlaceStatus.FIT);
		while (current != null) {
			if (!this.isInterrupted()) {
				PlaceStatus fitness = evaluator.testPlace(current);
				if (fitness == PlaceStatus.FIT) {
					if(!redundancyTester.isRedundant2(current, pM) && !implicitnessTester.isImplicit2(current, pM))
					pM.addPlace(current);
					if(pM.getPlaces().size()>60) {
						pM = redundancyTester.testForRedundancy(pM,25);
						pM = implicitnessTester.testByLPP2(pM);
						System.out.println("Reduced Places to "+pM.getPlaces().size() );
					}
				}
				long startTimeCandFind = System.currentTimeMillis();
				current = candidates.getNext(current, fitness);
				PlugInStatistics.instance().incTimeCandFind(System.currentTimeMillis() - startTimeCandFind);
			}
			else {
				System.out.println("!!!Timelimit for adding places has been reached!!!");
				break;
			}
		}
	}

	//G&S
	public MyProcessModel getpM() {
		return pM;
	}
}
